/*
 * Top of Configuration file < config.h >
 *
 * configurations file: Borland Graphics Interface for unix
 *
 * Copyright (c) 1992-94,95 Tokyo Denki University, Taiji Yamada
 */

/*
 * All C programs are written in ANSI-C,
 * so it is difficult to build by old C compiler.
 * If you do nothing, the compiler which compiled X is used.
 */
CC = gcc
/*CXX = g++*/

/*
 * If you are not super user, because you can't install in system,
 * please define InstallHome.
 */
/*#define InstallHome*/

#ifdef InstallHome
#define IncSubDir xbgi
LOCALDIR = $(HOME)/bin
LOCALINC = $(HOME)/include
LOCALLIB = $(HOME)/lib
LOCALMAN = $(HOME)/man/man3
INSTINCFLAGS = -m 0644
INSTMANFLAGS = -m 0644
XBGIBINDIR = $(LOCALDIR)
XBGIINCDIR = Concat($(LOCALINC)/,IncSubdir)
XBGILIBDIR = $(LOCALLIB)
XBGIMANDIR = $(LOCALMAN)
#else
#define IncSubdir xbgi
XBGIBINDIR = $(BINDIR)
XBGIINCDIR = Concat($(INCDIR)/,IncSubdir)
XBGILIBDIR = $(USRLIBDIR)
XBGIMANDIR = $(MANDIR)
#endif

XBGILIBREV = 3.0

/*
 * If you don't have xpm, please uncomment.
 * Xpm is used in xbgiloop() service and savepixmap() utility routines.
 */
#define EnableXpmlib

#ifdef EnableXpmlib
XPMLIB_DEFINE = -DENABLE_XPMLIB
XPMLIB = -lXpm
#else
XPMLIB_DEFINE = /**/
XPMLIB = /**/
#endif

/*
 * If you don't want to draw text in bi-lingual or multi-lingual,
 * please don't define both EnableBilingual and EnableMultilingual.
 * Bi-lingual method supports only japanese in this present version.
 * Multi-lingual method uses X11R5-6's XmbDrawText.
 * If your system works on i18n (internationalization),
 * please define EnableMultilingual.
 */
#define EnableBilingual japanese
/*#define EnableMultilingual*/

#if defined(EnableBilingual) && defined(EnableMultilingual)
#undef EnableBilingual
#endif
#ifdef EnableBilingual
LINGUAL_DEFINE = -DENABLE_BILINGUAL=EnableBilingual
#endif
#ifdef EnableMultilingual
LINGUAL_DEFINE = -DENABLE_MULTILINGUAL
#endif

/*
 * If you want to build concatenated library which links all graphic devices,
 * please define BuildConcatenatedLib.
 * If you want to build stand-alone libraries which work each graphic device,
 * please define BuildStandaloneLibs.
 * This version can not allow con-currently building both concatenated library
 * and stand-alone libraries.
 */
#define BuildConcatenatedLib
/*#define BuildStandaloneLibs*/

#if defined(BuildConcatenatedLib) && defined(BuildStandaloneLibs)
#undef BuildStandaloneLibs
#endif
#if defined(BuildConcatenatedLib)
XBGILIB = -lgraffit -lxbgi
#endif

/*
 * If you defined BuildConcatenatedLib mentioned above,
 * you must determine concatenated drivers by CONCATENATED_DRIVERS and
 * select a default driver in CONCATENATED_DRIVERS.
 */
#if defined(BuildConcatenatedLib)
CONCATENATED_DRIVERS = x11 ps
DefaultDriver = x11
DRIVER_DEFINE = -DXBGI_DEFAULT_DRIVER=$(DefaultDriver)_driver
#endif

/*
 * If you defined BuildStandaloneLibs mentioned above,
 * you must determine stand-alone libraries by BUILD_STANDALONE_LIBS and
 * hasten to select a default stand-alone library in BUILD_STANDALONE_LIBS.
 * A selected default stand-alone library is only used in gcb and gxb
 * which are easy-compile scripts for your xbgi program.
 */
#if defined(BuildStandaloneLibs)
BUILD_STANDALONE_LIBS = x11 ps
DefaultStandaloneLib = x11
#endif

#if defined(BuildStandaloneLibs)
XBGILIB = -lgraffit -lxbgi_$(DefaultStandaloneLib) -lxbgi_common -lxbgi_misc
#endif

/*
 * This definition is used in building concatenated library, libxbgi.a and so,
 * depending upon SharedLibraryTarget in X11/config/<os>Library.rule.
 */
#if (ProjectX < 6)
#define DownDir shared
#define UnsharedDownDir .
#define SharedDownDir DownDir
#else /* (ProjectX < 6) */
#define DownDir unshared
#define UnsharedDownDir DownDir
#define SharedDownDir .
#endif /* (ProjectX < 6) */

/*
 * I don't know how to build non-ELF format shared library on linux.
 */
#ifdef linux
#define UseElfFormat YES
#endif

/*
 * Normally, you don't have to edit below.
 */
DEFINES = $(LINGUAL_DEFINE) $(XPMLIB_DEFINE) $(DRIVER_DEFINE)
EXTRA_LOAD_FLAGS = -lm -L$(XBGILIBDIR)
LOCAL_LIBRARIES = $(XBGILIB) $(XTOOLLIB) $(XPMLIB) $(XLIB)
