/*
 * Header File < graphpn_.h >
 *
 * n-Dimensional Rotation Port for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHPN__H_
#define _GRAPHPN__H_
#include <math.h>
#include <graphp3_.h>
#include <graphrn_.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  nƩѴ(n-dimentinal Perspective Translation)ѥå
  
  nɸϤ3ɸϤѴ, 3ƩѴѥå
  ǸƤӽФȤˤäƥǥץ쥤n֤ᴶɽ뤿
  ѥåǤ.
  ΥѥånѴѥå(graphrn_.h)ưޤ.
  ˤ򺮺ߤƻѤǤΤ, 󥿥饯ƥ֤˻Ѵ,ƩѴ
  ڤؤ뤳ȤǽǤ.

  ѻԤλΥꤹˤsetdistance_( d )Ȥޤ.
  Υdͤμ¿Ǥ. ͤꤹȽĲȿžƤޤޤ.
  ޤΥdǤ뤳ȤϻʪΤƱɸˤ뤳Ȥˤʤ,
  ͷ׻ǤϥСեˤʤäƤޤΤդƤ.

  㤨Хǥץ쥤˲ۤĶľ(X:0..1,Y:0..2,Z:0..3,W:0..4)ˤ
  ʲΤ褦ˤޤ.
    double xf[4] = { 0, 0, 0, 0 };
    double xt[4] = { 1, 2, 3, 4 };
    setviewport_( 0, 100, 0, 100, !0 );           ̤100x100ΰȤ
    nhypermagnify_( 1.5 );                        ƤȤγΨ
    nhyperrotationport_( 4, xf, xt );             ˾βžΰ
    setrotation_( RAD(-15), RAD(20), 0 );         žѤ(X,Y,Z)
    nhyperrotate_( 0, 3, RAD(-15) );              žѤ(XW)
    nhyperrotate_( 1, 3, RAD(-30) );              žѤ(YW)
    nhyperrotate_( 2, 3, RAD(+10) );              žѤ(ZW)
    cubepn_( 4, xf, xt, !0 );                     žΰƱľΤ

  褷ĶľΤž nhyperrotation_ ٻꤷ,
  cubepn_ 褹뤳Ȥˤä̤βžѤĶľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

/*
 * (̾) linepn_      --- nƩѴ line     ľؿ
 *        linetopn_    --- nƩѴ lineto   а֤ؤľؿ
 *        putpixelpn_  --- nƩѴ putpixel ؿ
 *        movetopn_    --- nƩѴ moveto   ȥݥȰưؿ
 *        outtextxypn_ --- nƩѴ outtext  ƥȽϴؿ
 *
 * () linepn_     ( x1,x2 )
 *        linetopn_   ( x )
 *        putpixelpn_ ( x,c )
 *        movetopn_   ( x )
 *        outtextxypn_( x,str )
 *        double *x1; nɸ(٥ȥǳǼ)
 *        double *x2; nɸ(٥ȥǳǼ)
 *        double *x;  nɸ(٥ȥǳǼ)
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³nƩѴѤδؿǤ
 *        nĶ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphr3_.h 
 */
extern void linepn_( double *x1, double *x2 );
extern void linetopn_( double *x );
extern void putpixelpn_( double *x, int c );
extern void movetopn_( double *x );
extern void outtextxypn_( double *x, char *str );

/*
 * (̾) cubepn_ --- nƩѴ cube ľΤ
 *
 * () cubepn_( xf, xt, flg )
 *        double xf; 1(٥ȥǳǼ)
 *        double xt; 2(٥ȥǳǼ)
 *        int flg;   !0ξʬ򥫥顼ɽ
 *
 * () nĶ֤12ϤĶΩΤnƩѴ褷ޤ
 */
extern void cubepn_( double *xf, double *xt, int flg );

/*
 * (̾) linespn_     --- nƩѴ lines     ʣľؿ
 *        putpixelspn_ --- nƩѴ putpixels ʣؿ
 *
 * () linespn_    ( np, rnpoints )
 *        putpixelspn_( np, rnpoints, c )
 *        int np;            ꤹɸο
 *        double **rnpoints; nɸΥ٥ȥ
 *        int c;             ѥåֹ
 *
 * () n֤ľꤵ줿ޤȤ褷ޤ
 *        doubleι rnpoints ˤnɸ
 *        rnpoints[0..np-1][0..n-1] ǳǼƲ
 */
extern void linespn_( int np, double **rnpoints );
extern void putpixelspn_( int np, double **rnpoints, int c );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif 
