/*
 * Header File < graphr3_.h >
 *
 * 3-dimensional Rotation Port for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHR3__H_
#define _GRAPHR3__H_
#include <math.h>
#include <graphr2_.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif
#ifndef DEG
# define DEG(r) (180.0/M_PI*(r))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  3Ѵ(3-dimensional Rotation Port Translation)ѥå
  
  3ɸϤɺɸϤѴ, ɥѴѥå
  ǸƤӽФȤˤäƥǥץ쥤3֤ʿƩɽ뤿
  ѥåǤ. ʪΤ˱ᴶƩѴԤȤ,
  ΥѥåǤϤʤƩѴѥågraphp3_.hȤɬפޤ.
  
  ΥѥåŪǤդ3֤ǥץ쥤Ƥ뤳ȤǤ.
  Ǥդ3֤ǤΤǤΩΤǤɬפϤޤ.
  Ǽ¿3֤žΰ(Rotation Port)ȸƤӤޤ.
  ΥѥåǤϤβžΰƼʬ˲žѴܤ
  ɺɸϤΩΤȤƤޤ.
  㤨Хǥץ쥤˲ۤľ(X:0..1,Y:0..2,Z:0..3)ˤ
  ʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify_( 1.5 );                   ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžΰ
    setrotation_( RAD(-15), RAD(20), 0 ); žѤ
    cuber3_( 0, 0, 0, 1, 2, 3, !0 );      žΰƱľΤ

  setviewport_ˤƲĤޤʤ褦ΰꤷޤ.
  褷ľΤžsetrotationٻꤷ,
  cuber3_褹뤳Ȥˤä̤βžѤľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

struct rotationporttype_ {
  double ox, oy, oz;
  double mx, my, mz;
  double mag;
  double r[3][3];
};

extern struct rotationporttype_ __RP;

/*
 * (̾) r3tox --- 3ɸƤ줿Xɸޥ
 *        r3toy --- 3ɸƤ줿Yɸޥ
 *        r3toz --- 3ɸƤ줿Zɸޥ
 *
 * () r3tox( x,y,z )
 *        r3toy( x,y,z )
 *        r3toz( x,y,z )
 *        double x, y, z; 4ɸ
 *
 * () setmagnify_  setrotation_ ǻꤵ줿žѤǡ
 *        3ɸž줿3ɸγơκɸޤ
 */
#define r3tox(x,y,z) (__RP.mx*((x)-__RP.ox)*__RP.r[0][0]\
                     +__RP.my*((y)-__RP.oy)*__RP.r[1][0]\
                     +__RP.mz*((z)-__RP.oz)*__RP.r[2][0])
#define r3toy(x,y,z) (__RP.mx*((x)-__RP.ox)*__RP.r[0][1]\
                     +__RP.my*((y)-__RP.oy)*__RP.r[1][1]\
                     +__RP.mz*((z)-__RP.oz)*__RP.r[2][1])
#define r3toz(x,y,z) (__RP.mx*((x)-__RP.ox)*__RP.r[0][2]\
                     +__RP.my*((y)-__RP.oy)*__RP.r[1][2]\
                     +__RP.mz*((z)-__RP.oz)*__RP.r[2][2])

/*
 * (̾) liner3_      --- 3Ѵ line     ľޥ
 *        linetor3_    --- 3Ѵ lineto   а֤ؤľޥ
 *        putpixelr3_  --- 3Ѵ putpixel ޥ
 *        movetor3_    --- 3Ѵ moveto   ȥݥȰưޥ
 *        outtextxyr3_ --- 3Ѵ outtext  ƥȽϥޥ
 *
 * () liner3_     ( x1,y1,z1, x2,y2,z2 )
 *        linetor3_   ( x,y,z )
 *        putpixelr3_ ( x,y,z,c )
 *        movetor3_   ( x,y,z )
 *        outtextxyr3_( x,y,z,str )
 *        double x1,y1,z1; 3ɸ
 *        double x2,y2,z2; 3ɸ
 *        double x,y,z;    3ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³3ѴѤΥޥǤ
 *        3Ķ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        2ɥѴѥå graphr2_.h 
 */
#define liner3_(x1,y1,z1,x2,y2,z2) \
        line_(r3tox(x1,y1,z1),r3toy(x1,y1,z1),\
	      r3tox(x2,y2,z2),r3toy(x2,y2,z2))
#define linetor3_(x,y,z) \
	lineto_(r3tox(x,y,z),r3toy(x,y,z))
#define putpixelr3_(x,y,z,c) \
	putpixel_(r3tox(x,y,z),r3toy(x,y,z),c)
#define movetor3_(x,y,z) \
	moveto_(r3tox(x,y,z),r3toy(x,y,z))
#define outtextxyr3_(x,y,z,str) \
	outtextxy_(r3tox(x,y,z),r3toy(x,y,z),str)

/*
 * (̾) setrotationport_ --- 3ƩѴѡɸ롼
 *
 * () setrotationport_( xf,yf,zf, xt,yt,zt )
 *        double xf,yf,zf; 1
 *        double xt,yt,zt; 2
 *
 * () 12ϤΩΤ3ƩѴΰȤޤ
 */
extern void setrotationport_( double xf, double yf, double zf,
                             double xt, double yt, double zt );

/*
 * (̾) setmagnify_ --- 3ƩѴѡΨ롼
 *
 * () hypermagnify_( rm )
 *        double rm;    Ψ
 *
 * () 3ʪΤ2ƩƤȤγΨꤷޤ
 *        rm = 1.0 ΤȤʿƤȤʤޤѴؿ
 *        ºݤ˥ǥץ쥤褵줿Ȥ˾ޤΤǡ
 *        rm = 1.5 餤礦ɤǤ礦
 */
extern void setmagnify_( double rm );

/*
 * (̾) setrotation_ --- 3ƩѴѡƳѻ롼
 *
 * () setrotation_( a, b, c );
 *        double a; Xž(饸)
 *        double b; Yž(饸)
 *        double c; Zž(饸)
 *
 * () 3ʪΤ2ƩƤȤƳѤꤷޤ
 */
extern void setrotation_( double a, double b, double c );

/*
 * (̾) setrotatex_ --- 3ƩѴѡXž롼
 *        setrotatey_ --- 3ƩѴѡYž롼
 *        setrotatez_ --- 3ƩѴѡZž롼
 *
 * () setrotate?_( d );
 *        double d; ž(饸)
 *
 * () 3ʪΤ2ƩƤȤβžѤꤷޤ
 *        ȤƳѤꤵ줿٤žޤ
 */
extern void setrotatex_( double d );
extern void setrotatey_( double d );
extern void setrotatez_( double d );

/*
 * (̾) cuber3_ --- 3Ѵ cube ľΤ
 *
 * () cuber3_( xf,yf,zf, xt,yt,zt, flg )
 *        double xf,yf,zf; 1
 *        double xt,yt,zt; 2
 *        int flg;         ̤
 *
 * () 3ζ֤12ϤΩΤ3Ѵ褷ޤ
 */
extern void cuber3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg );

extern void boxr3_( double xf, double yf, double zf,
                   double xt, double yt, double zt, int c6[] );

extern void lefthandr3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg );

/*
 * (̾) linesr3_     --- 3Ѵ lines     ʣľؿ
 *        putpixelsr3_ --- 3Ѵ putpixels ʣؿ
 *
 * () linesr3_    ( n, r3points )
 *        putpixelsr3_( n, r3points, c )
 *        int n;                ꤹɸο
 *        double *r3points;     3ɸ¤
 *        int c;                ѥåֹ
 *
 * () 3֤ľꤵ줿ޤȤ褷ޤ
 *        double r3points ˤ3ɸ٥¤ӤǳǼƲ
 */
extern void linesr3_( int __numpoints, double *__r3points );
extern void putpixelsr3_( int __numpoints, double *__r3points, int __color );

/*
 * (̾) getrotation_ --- 3ƩѴѥƳѼؿ
 *
 * () getrotation_( a, b, c )
 *        double *a, *b, *c; ƳѼΤΥݥ
 *
 * () setrotation_  setrotatex_, setrotatey_, setrotatey_ ʤɤ
 *        žĤޤꥫȤβž󤫤顢
 *        Y-X-ZžгѲža, b, cǥ֤ޤ
 */
extern void getrotation_( double *a, double *b, double *c );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
