/*
 * Header File < graphs3_.h >
 *
 * 3-Dimensional Stereo Graphics Interface for BGI
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHS3__H_
#define _GRAPHS3__H_
#include <graphics.h>
#include <graphr2_.h>
#include <graphs3_.h>
#include <graphp3_.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  3ƥ쥪եå(3-dimensional Stereo Graphics)ѥå
  
  3ɸϤ2ƩѴܤ,
  Ωλ¸뤿ΥѥåǤ.
  ̿'sl_'ղäΤѤ̿,
  'sr_'ղäΤѤ̿Ǥ.
  ޤ,Ʊ̿ѰդƤ, ̿'s3_'
  ղä̾ΤˤʤäƤޤ. ǥեͤǺѴֿ򥻥å,
  ѴĿ򥻥åȤԤޤ. ѹǽǤ.

  㤨Хǥץ쥤˥ƥ쥪եåľ(X:0..1,Y:0..2,Z:0..3)
  ˤϰʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify( 1.5 );                    ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 ); žѤ
    setdistance_( 0.5 );                  Υ
    stereodistance_( 0.5 );               ƥ쥪ջΥ
    cubes3_( 0, 0, 0, 1, 2, 3, !0 );      žɸϤƱľΤ

  ʲΤ褦ΩλμˡѹǤޤ
    setstereotype( ColorGlass );          ᥬΩλ
    setstereotype( DoubleImage );         2Ωλ

  ޤʲΤ褦˥桼ΩλѼ³Ǥޤ
    setstereoprocedures( start_proc, left_proc, right_proc, end_proc );

  2ΩλΤȤϡʲΤ褦ѹǤޤ
  widthʤˡˤʤޤ
    stereowidthimages( width );
 */

struct stereographtype_ {
  double dist;                /* stereo distance */
  void (*start)(void);        /* start procedure */
  void (*left) (void);        /* left procedure */
  void (*right)(void);        /* right procedure */
  void (*end)  (void);        /* end procedure */
  int c;                      /* keep current color */
  struct fillsettingstype fs; /* keep current fill settings */
  struct viewporttype_ v;     /* keep current viewport settings */
  int wi;                     /* width between double images (bits) */
};

extern struct stereographtype_ __SG;

enum { ColorGlass, DoubleImage };

/*
 * (̾) sltox --- 3ɸ麸ܤƩƤ줿Xɸޥ
 *        sltoy --- 3ɸ麸ܤƩƤ줿Yɸޥ
 *        sltoz --- 3ɸ麸ܤƩƤ줿Zɸޥ
 *
 * () sltox( x,y,z )
 *        sltoy( x,y,z )
 *        sltoz( x,y,z )
 *        double x, y, z; 3ɸ
 *
 * () setmagnify_  setrotation_ ǻꤵ줿žѤǡ3ɸ
 *        ܤƩѴ줿3ɸγơκɸޤ
 */
#define sltox(x,y,z) ((r3tox(x,y,z)+__SG.dist)*__PP.dist/(r3toz(x,y,z)+__PP.deform))
#define sltoy(x,y,z) p3toy(x,y,z)
#define sltoz(x,y,z) p3toz(x,y,z)

/*
 * (̾) linesl_      --- 3ƩѴ line     ľ
 *        linetosl_    --- 3ƩѴ lineto   а֤ؤľ
 *        putpixelsl_  --- 3ƩѴ putpixel 
 *        movetosl_    --- 3ƩѴ moveto   ȥݥȰư
 *        outtextxysl_ --- 3ƩѴ outtext  ƥȽ
 *
 * () linesl_     ( x1,y1,z1, x2,y2,z2 )
 *        linetosl_   ( x,y,z )
 *        putpixelsl_ ( x,y,z,c )
 *        movetosl_   ( x,y,z )
 *        outtextxysl_( x,y,z,str )
 *        double x1,y1,z1; 3ɸ
 *        double x2,y2,z2; 3ɸ
 *        double x,y,z;    3ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³3ƩѴѤΥޥǤ
 *        3ζ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphp3_.h
 */
#define linesl_(x1,y1,z1,x2,y2,z2) \
        line_(sltox(x1,y1,z1),sltoy(x1,y1,z1), \
              sltox(x2,y2,z2),sltoy(x2,y2,z2))
#define linetosl_(x,y,z) \
        lineto_(sltox(x,y,z),sltoy(x,y,z))
#define putpixelsl_(x,y,z,c) \
        putpixel_(sltox(x,y,z),sltoy(x,y,z),c)
#define movetosl_(x,y,z) \
        moveto_(sltox(x,y,z),sltoy(x,y,z))
#define outtextxysl_(x,y,z,str) \
        outtextxy_(sltox(x,y,z),sltoy(x,y,z),str)

/*
 * (̾) srtox --- 3ɸ鱦ܤƩƤ줿Xɸޥ
 *        srtoy --- 3ɸ鱦ܤƩƤ줿Yɸޥ
 *        srtoz --- 3ɸ鱦ܤƩƤ줿Zɸޥ
 *
 * () srtox( x,y,z )
 *        srtoy( x,y,z )
 *        srtoz( x,y,z )
 *        double x, y, z; 3ɸ
 *
 * () setmagnify_  setrotation_ ǻꤵ줿žѤǡ3ɸ
 *        ܤƩѴ줿3ɸγơκɸޤ
 */
#define srtox(x,y,z) ((r3tox(x,y,z)-__SG.dist)*__PP.dist/(r3toz(x,y,z)+__PP.deform))
#define srtoy(x,y,z) p3toy(x,y,z)
#define srtoz(x,y,z) p3toz(x,y,z)

/*
 * (̾) linesr_      --- 3ƩѴ line     ľ
 *        linetosr_    --- 3ƩѴ lineto   а֤ؤľ
 *        putpixelsr_  --- 3ƩѴ putpixel 
 *        movetosr_    --- 3ƩѴ moveto   ȥݥȰư
 *        outtextxysr_ --- 3ƩѴ outtext  ƥȽ
 *
 * () linesr_     ( x1,y1,z1, x2,y2,z2 )
 *        linetosr_   ( x,y,z )
 *        putpixelsr_ ( x,y,z,c )
 *        movetosr_   ( x,y,z )
 *        outtextxysr_( x,y,z,str )
 *        double x1,y1,z1; 3ɸ
 *        double x2,y2,z2; 3ɸ
 *        double x,y,z;    3ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³3ƩѴѤΥޥǤ
 *        3ζ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphp3_.h
 */
#define linesr_(x1,y1,z1,x2,y2,z2) \
        line_(srtox(x1,y1,z1),srtoy(x1,y1,z1), \
	      srtox(x2,y2,z2),srtoy(x2,y2,z2))
#define linetosr_(x,y,z) \
        lineto_(srtox(x,y,z),srtoy(x,y,z))
#define putpixelsr_(x,y,z,c) \
        putpixel_(srtox(x,y,z),srtoy(x,y,z),c)
#define movetosr_(x,y,z) \
        moveto_(srtox(x,y,z),srtoy(x,y,z))
#define outtextxysr_(x,y,z,str) \
        outtextxy_(srtox(x,y,z),srtoy(x,y,z),str)

/*
 * (̾) lines3_      --- 3ξƩѴ line     ľ
 *        linetos3_    --- 3ξƩѴ lineto   а֤ؤľ
 *        putpixels3_  --- 3ξƩѴ putpixel 
 *        movetos3_    --- 3ξƩѴ moveto   ȥݥȰư
 *        outtextxys3_ --- 3ξƩѴ outtext  ƥȽ
 *
 * () lines3_     ( x1,y1,z1, x2,y2,z2 )
 *        linetos3_   ( x,y,z )
 *        putpixels3_ ( x,y,z,c )
 *        movetos3_   ( x,y,z )
 *        outtextxys3_( x,y,z,str )
 *        double x1,y1,z1; 3ɸ
 *        double x2,y2,z2; 3ɸ
 *        double x,y,z;    3ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³3ξƩѴѤΥޥǤ
 *        3ζ֤ο޷ΩλǴñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphp3_.h
 */
#define lines3_(x1,y1,z1,x2,y2,z2) \
                               do{__SG.start(); \
                                  __SG.left(); linesl_(x1,y1,z1,x2,y2,z2); \
                                  __SG.right();linesr_(x1,y1,z1,x2,y2,z2); \
                                  __SG.end();} while(0)
#define linetos3_(x,y,z)       do{__SG.start(); \
                                  __SG.left(); linetosl_(x,y,z); \
                                  __SG.right();linetosr_(x,y,z); \
                                  __SG.end();} while(0)
#define putpixels3_(x,y,z,c)   do{__SG.start(); \
                                  __SG.left(); putpixelsl_(x,y,z,getcolor()); \
                                  __SG.right();putpixelsr_(x,y,z,getcolor()); \
                                  __SG.end();} while(0)
#define movetos3_(x,y,z)       do{__SG.start(); \
                                  __SG.left(); movetosl_(x,y,z); \
                                  __SG.right();movetosr_(x,y,z); \
                                  __SG.end();} while(0)
#define outtextxys3_(x,y,z,str) \
                               do{__SG.start(); \
                                  __SG.left(); outtextxysl_(x,y,z,str); \
                                  __SG.right();outtextxysr_(x,y,z,str); \
                                  __SG.end();} while(0)

extern void stereowidthimages( int width );

extern void setstereoprocedures( void (*start)(void),
                                void (*left)(void),
				void (*right)(void),
                                void (*end)(void) );

extern void setstereotype( int type );

/*
 * (̾) stereodistance_ --- 3ƥ쥪ѡξΥ롼
 *
 * () stereodistance_( d )
 *        double d; ξΥ
 *
 * () ξΥ d μ¿Ǥۤ d = 0.02 餤侩ͤǤ
 */
extern void stereodistance_( double d );

/*
 * (̾) cubes3_ --- 3ƥ쥪 cube ľΤ
 *
 * () cubes3_( xf,yf,zf, xt,yt,zt, flg )
 *        double xf,yf,zf; 1
 *        double xt,yt,zt; 2
 *        int flg;         ̤
 *
 * () 3ζ֤12ϤΩΤ3ƥ쥪դ褷ޤ
 */
extern void cubes3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg );

extern void boxs3_( double xf, double yf, double zf, double xt,
                   double yt, double zt, int c6[] );

extern void lefthands3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg );

/*
 * (̾) liness3_     --- 3ƥ쥪 lines     ʣľؿ
 *        putpixelss3_ --- 3ƥ쥪 putpixels ʣؿ
 *
 * () liness3_    ( n, r3points )
 *        putpixelss3_( n, r3points, c )
 *        int n;                ꤹɸο
 *        double *r3points;     3ɸ¤
 *        int c;                ѥåֹ
 *
 * () 3֤ľꤵ줿ޤȤ褷ޤ
 *        double r3points ˤ3ɸ٥¤ӤǳǼƲ
 */
extern void liness3_( int n, double *r3points );
extern void putpixelss3_( int n, double *r3points, int c );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _GRAPHS3__H_ */
