/*
 * Header File < graphsn_.h >
 *
 * n-Dimensional Rotation Port for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHSN__H_
#define _GRAPHSN__H_
#include <math.h>
#include <graphs3_.h>
#include <graphpn_.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  nƥ쥪եå(n-dimensional Stereo Graphics)ѥå
  
  nɸϤ3ɸϤѴ, 3βžɸϤ
  2ƩѴܤ, Ωλ¸뤿ΥѥåǤ.

  㤨Хǥץ쥤˲ۤĶľ(X:0..1,Y:0..2,Z:0..3,W:0..4)ˤ
  ʲΤ褦ˤޤ.
    double xf[4] = { 0, 0, 0, 0 };
    double xt[4] = { 1, 2, 3, 4 };
    setviewport_( 0, 100, 0, 100, !0 );           ̤100x100ΰȤ
    nhypermagnify_( 1.5 );                        ƤȤγΨ
    nhyperrotationport_( 4, xf, xt );             ˾βžΰ
    setrotation_( RAD(-15), RAD(20), 0 );         žѤ(X,Y,Z)
    nhyperrotate_( 0, 3, RAD(-15) );              žѤ(XW)
    nhyperrotate_( 1, 3, RAD(-30) );              žѤ(YW)
    nhyperrotate_( 2, 3, RAD(+10) );              žѤ(ZW)
    cubesn_( 4, xf, xt, !0 );                     žΰƱľΤ

  褷ĶľΤž nhyperrotation_ ٻꤷ,
  cubesn_ 褹뤳Ȥˤä̤βžѤĶľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

/*
 * (̾) linesn_      --- nƥ쥪 line     ľ
 *        linetosn_    --- nƥ쥪 lineto   а֤ؤľ
 *        putpixelsn_  --- nƥ쥪 putpixel 
 *        movetosn_    --- nƥ쥪 moveto   ȥݥȰư
 *        outtextxysn_ --- nƥ쥪 outtext  ƥȽ
 *
 * () linesn_     ( x1,x2 )
 *        linetosn_   ( x )
 *        putpixelsn_ ( x,c )
 *        movetosn_   ( x )
 *        outtextxysn_( x,str )
 *        double *x1; nɸ(٥ȥǳǼ)
 *        double *x2; nɸ(٥ȥǳǼ)
 *        double *x;  nɸ(٥ȥǳǼ)
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³nƥ쥪ѤδؿǤ
 *        nĶ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphr3_.h 
 *        3ƩѴѥå graphp3_.h 
 *        3ƥ쥪եѥå graphs3_.h
 */
extern void linesn_( double *x1, double *x2 );
extern void linetosn_( double *x );
extern void putpixelsn_( double *x, int c );
extern void movetosn_( double *x );
extern void outtextxysn_( double *x, char *str );

/*
 * (̾) cubesn_ --- nƥ쥪 cube ľΤ
 *
 * () cubesn_( xf, xt, flg )
 *        double xf; 1(٥ȥǳǼ)
 *        double xt; 2(٥ȥǳǼ)
 *        int flg;   !0ξʬ򥫥顼ɽ
 *
 * () nĶ֤12ϤĶΩΤnƥ쥪դ
 *        褷ޤ
 */
extern void cubesn_( double *xf, double *xt, int flg );

/*
 * (̾) linessn_     --- nƥ쥪 lines     ʣľؿ
 *        putpixelssn_ --- nƥ쥪 putpixels ʣؿ
 *
 * () linessn_    ( np, rnpoints )
 *        putpixelssn_( np, rnpoints, c )
 *        int np;            ꤹɸο
 *        double **rnpoints; nɸΥ٥ȥ
 *        int c;             ѥåֹ
 *
 * () n֤ľꤵ줿ޤȤ褷ޤ
 *        doubleι rnpoints ˤnɸ
 *        rnpoints[0..np-1][0..n-1] ǳǼƲ
 */
extern void linessn_( int np, double **rnpoints );
extern void putpixelssn_( int np, double **rnpoints, int c );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif 
