/*
 * Sample Program for Event Driven Programing by C++ < julia.c >
 *
 * ٥ȶưץߥ󥰤Τ C++ ˤ륵ץ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <complex.h>
#include <graphics.h>
#include <coloring.h>

#ifdef _XBGI_
#  define PD "-title JuliaSet -geometry 500x500 -ncolor 100"
#else
#  include <xbgi2bgi.h>
#  define PD "c:/borlandc/bgi"
#endif

/*
 * ꥢ
 *
 * $f: C \to C$ ˤ, \[ f(z) = z^3 + a \] ˤĤ,
 *  \[ f(z) = 0 \] ˥˥塼ȥˡŬѤ,
 *  $z_{n+1} = z_n - f(z_n)/f'(z_n)f$ .
 * ϳطϤ $z_0$ ͤˤä, 뺬ؤμ«ȯޤ.
 * Ǥ $z_0$ ȯʤͤν򥸥ꥢȸƤ.
 *
 * ץǤ $\infty$  ITIME, «Ȥߤʤͤ $|z|=$ CONVERGE Ȥ.
 * ޤ $z_0$  $z_0 \in [z1,z2]$ Ȥ.
 */

/*
 * $z_n$ ϳطϤ«˻ä֤.
 * $\infty$ ȸʤƤ ITIME ˼«ʤä, ITIME ֤.
 * ޤ, ɤβ˼« INDEX ֤,
 *  C  INDEX ܤ˳Ǽ.
 */
int ITIME = 50;
double CONVERGE = 1.0e-6;
complex A( 1.0, 0.0 );
complex *C = NULL;
int N = 0, INDEX;
int julia( complex z0 )
{
  int i, j;
  complex zn1, zn = z0;

  if ( abs(zn) == 0.0 ) return ITIME;
  for ( i=0; i<ITIME; i++ ){
    zn1 = 2.0*zn/3 + A/zn/zn/3;
    if ( abs(zn1-zn) < abs(zn)*CONVERGE ){
      for ( j=0; j<N; j++ )
        if ( abs(zn1-C[j]) < CONVERGE ){
          INDEX = j;
          return i;
        }
      if ( j==N ){
        N++;
        if ( C == NULL )
          C = (complex*)malloc( N*sizeof(complex) );
        else
          C = (complex*)realloc( C, N*sizeof(complex) );
        C[j] = zn1;
        INDEX = j;
      }
      return i;
    }
    zn = zn1;
  }
  return ITIME;
}

/*
 * SIZExSIZEϰϤ1Ǥ򥸥ꥢμ«ˤäƥڥȤ.
 * Υ롼ϸƤФ뤿Ӥ̩٤⤯ʤäƤ.
 * X, Y ϥӥ塼ݡȤλ. VWX, VWY ʪɸɸѴޥ.
 * divide, radius, draw_x, draw_y Ͻΰʬ, ʬΰĹ,
 * ɤĤ֤Ƥʪɸ򼨤Ƥ.
 */
int X, Y, SIZE, MAXCOLOR;
complex z1( -1.5, -1.5 ), z2( 1.5, 1.5 );
#define VWX(x) ((double)(x)/SIZE*(real(z2)-real(z1))+real(z1))
#define VWY(y) ((double)(y)/SIZE*(imag(z2)-imag(z1))+imag(z1))
int divide, radius, draw_x, draw_y;
void drawing( void )
{
  radius = SIZE/divide;
  if ( radius == 0 ) return;

  complex z( VWX( draw_x+radius/2 ), VWY( draw_y+radius/2 ) );
  int n = julia( z );
  setfillstyle( SOLID_FILL, (ITIME-n)%(MAXCOLOR-1)+1 );
  bar( draw_x, draw_y, draw_x+radius-1, draw_y+radius-1 );

  draw_x += radius;
  if ( draw_x > SIZE ){
    draw_x = 0;
    draw_y += radius;
    if ( draw_y > SIZE ){
      draw_y = 0;
      divide *= 2;
    }
  }
}

/*
 * ޥΥܥ1ΰλ, ܥ1ΰ褬ޤ.
 * ƥޥΥܥ2ǻꤵ줿ΰγ򳫻Ϥ.
 * ESCǽλ. '*'ǥѥåȤβž.
 * '1','2','3'ǥ顼ۿ򴹤뤳ȤǤ.
 */
int prs_x, prs_y, prs_flag = 0;
int rls_x, rls_y, rls_flag = 0;
int mov_x, mov_y, mov_flag = 0;

int button_press( int button, int x, int y )
{
  if ( button == 1 ){
    if ( mov_flag )
      rectangle( prs_x, prs_y, mov_x, mov_y );
    prs_x = x - X;
    prs_y = y - Y;
    prs_flag = !0;
    rls_flag = 0;
    mov_flag = 0;
  }else if ( button == 2 )
    if ( prs_flag && rls_flag ){
      z1 = complex( VWX( prs_x ), VWY( prs_y ) );
      z2 = complex( VWX( rls_x ), VWY( rls_y ) );
      draw_x = 0;
      draw_y = 0;
      divide = 2;
      prs_flag = 0;
      rls_flag = 0;
      mov_flag = 0;
    }
  return !0;
}
int button_release( int button, int x, int y )
{
  if ( button == 1 && prs_flag ){
    if ( prs_x != rls_x && prs_y != rls_y ){
      rls_x = x - X;
      rls_y = y - Y;
      rls_flag = !0;
    }else{
      prs_flag = 0;
      mov_flag = 0;
    }
  }else
    prs_flag = 0;
  return !0;
}
int mouse_motion( int button, int x, int y )
{
  if ( button == 1 && prs_flag ){
    if ( !mov_flag ){
      mov_x = prs_x;
      mov_y = prs_y;
    }
    mov_flag = !0;
    rectangle( prs_x, prs_y, mov_x, mov_y );
    rectangle( prs_x, prs_y, x - X, y - Y );
    mov_x = x - X;
    mov_y = y - Y;
  }
  return !0;
}
int key_press( int c )
{
  switch ( c ){
  case '*': rotate_colors( 1, MAXCOLOR-1 ); break;
  case '1': coloring ( 1, MAXCOLOR-1 ); break;
  case '2': coloring2( 1, MAXCOLOR-1, WHITE, BLACK ); break;
  case '3': coloring3( 1, MAXCOLOR-1, RED, GREEN, BLUE ); break;
  case 0x1b: return 0;
  }
  return !0;
}
int configure( void )
{
  static int size = 0;

  SIZE = min(getmaxx(),getmaxy()) + 1;
  if ( SIZE != size ){
    setsizexy(getmaxx()+1,getmaxy()+1);
    X = (getmaxx()+1)/2 - SIZE/2;
    Y = (getmaxy()+1)/2 - SIZE/2;
    setviewport( X, Y, X+SIZE-1, Y+SIZE-1, !0 );
    cleardevice();
    size = SIZE;
    divide = 2;
    draw_x = 0;
    draw_y = 0;
  }
  MAXCOLOR = getmaxcolor();
  if ( MAXCOLOR - 2 > ITIME ) ITIME = MAXCOLOR - 2;
  setcolor( MAXCOLOR );
  setwritemode( XOR_PUT );
  prs_flag = 0;
  rls_flag = 0;
  mov_flag = 0;
  draw_x = 0;
  draw_y = 0;
  return !0;
}
int noevent( void )
{
  if ( !mov_flag )
    drawing();
  return !0;
}

/*
 * ᥤǥ٥ȼ³Ԥ
 */
int main( void )
{
  int gd = DETECT, gm;

  initgraph( &gd, &gm, PD );
  coloring( 1, getmaxcolor()-1 );

  set_button_press_handler  ( button_press   );
  set_button_release_handler( button_release );
  set_mouse_motion_handler  ( mouse_motion   );
  set_key_press_handler     ( key_press      );
  set_configure_handler     ( configure      );
  set_noevent_handler       ( noevent        );
  
  configure();
  xbgiloop(); /* ٥ȥ롼 */

  closegraph();
  return 0;
}
