/*
 * Sample Program of BGI library for both BGI and XBGI < sponge.c >
 *
 * BGI ΤΥ饤֥ graphp3_.h Υץ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <graphics.h>
#include <graphp3_.h> /* ᴶĤR^3֤򥵥ݡȤ륤󥯥롼ɥե */

void sponge( int n, double x, double y, double z, double l )
{
  int i, j, k;
  int c[6];

  if ( n <= 0 )
    return;
  c[0]=c[2]=c[4]= (10+n)%16; c[1]=c[3]=c[5]= (10+n)%16 - 8;
  boxp3_( x+l/6, y+l/6, z+l/6, x-l/6, y-l/6, z-l/6, c ); /* Ȣ */
  for ( i=-1; i<2; i+=1 )
    for ( j=-1; j<2; j+=1 )
      for ( k=-1; k<2; k+=1 )
        if ( i!=0 || j!=0 || k!=0 )
          sponge( n-1, x+l/3*i, y+l/3*j, z+l/3*k, l/3 );
}

int main( void )
{
  int gd = DETECT, gm;
  int n = 2, key = 'r';
  double x = 0, y = 0, z = 0, l = 1;
  int ROTX = -15, ROTY = 10, ROTZ = 0; /* ž */
  double SX = 0.0, SY = 0.0; /* 濴 */
  double DST = 0.2; /* Υ */

  initgraph_( &gd, &gm, "-geometry 400x400 -title sponge" );
  cleardevice();

  do {
    switch( key ) {
    case 'r': cleardevice(); break;
    case '2': ROTX -= 5; ROTX = (ROTX+360)%360; break;
    case '8': ROTX += 5; ROTX = (ROTX+360)%360; break;
    case '4': ROTY += 5; ROTY = (ROTY+360)%360; break;
    case '6': ROTY -= 5; ROTY = (ROTY+360)%360; break;
    case '5': ROTX = ROTY = 0.0; break;
    case 'x': SY -= 0.05; break;
    case 'e': SY += 0.05; break;
    case 's': SX -= 0.05; break;
    case 'd': SX += 0.05; break;
    case 'c': SX = SY = 0.0; break;
    case 'f': DST *= 0.9; break;
    case 'b': DST *= 1.1; break;
    case 'g': DST  = 0.2; break;
    case 'n': n = min(n+1,3); break;
    case 'p': n = max(0,n-1); break;
    }
    switch( key ){
    case 'r':
    case '2': case '8': case '4': case '6': case '5':
    case 'x': case 'e': case 's': case 'd': case 'c':
    case 'f': case 'g': case 'b':
    case 'n': case 'p':
      setviewport_( 0, 0, 400-1, 400-1, !0 );
      setwindow_( -1.0-SX, 1.0-SY, 1.0-SX, -1.0-SY );
      setrotationport_( -1, -1, -1, 1, 1, 1 ); /* žɸ礭λ */
      setrotation_( RAD(ROTX), RAD(ROTY), RAD(ROTZ) ); /* žѤλ */
      setdistance_( DST );
      cleardevice();
      sponge( n, x, y, z, l ); 
      break;
    }
  } while ( (key=getch()) != 0x1b );
  closegraph();
  return 0;
}
