/*
 * Japanese code system utilities < jutil.h >
 *
 * ܸΥηϤ˴ؤ桼ƥƥ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _JUTIL_H_
#define _JUTIL_H_

#define s2code(s) ((unsigned short)(s[0]<<8|s[1]))
#define codec1(c) ((char)((c)>>8))
#define codec2(c) ((char)((c)&0x00ff))

#ifndef __JCTYPE_H
/*
 * (̾) iskana   --- եJISɤΥʸؿ
 *        iskanji  --- եJISɤδ̸ؿ
 *        iskanji2 --- եJISɤδ̸ؿ
 *        jmstojis --- եJISJISؤΥѴ
 *        jistojms --- JIS饷եJISؤΥѴ
 *
 * ()
 *        MSDOS
 *        #include <jctype.h>
 *        UNIX &
 *        #include <jutil.h>
 *
 *        int iskana(c)
 *        int iskanji(c)
 *        int iskanji2(c)
 *        unsigned short c; оʸ
 *
 *        unsigned short jmstojis( c )
 *        unsigned short jistojms( c )
 *        unsigned short c; оʸ
 *
 * ()
 *        줾Borland C++ʤɤMSDOSѥΥޥ˥奢򸫤Ʋ.
 *
 * (­)
 *        ܸMSDOSΥѥѰդƤ륷եJIS
 *        ܸ쥳ɤΥ롼ΰUNIXإݡȤΤǤ.
 *        ܸ쥳ɤΥ롼ƤѤˤۺjmskanji-1.0
 *        jctype.h򤳤jutil.hޤ˥󥯥롼ɤɬפޤ.
 */
/*
 * (̾) shiftjis --- ܸ쥷եJISʸ
 *
 * ()
 *        եJISɽʸ, ASCIIʸΥեåʸΰ
 *        ɤѤ, ХȤΥեJISɤǳǼ.
 */
#define _KNJ_M  ((char)0x01) /* Non-punctuation of Kana-set */
#define _KNJ_P  ((char)0x02) /* Punctuation of Kana-set */
#define _KNJ_1  ((char)0x04) /* Legal 1st byte of double byte stream */
#define _KNJ_2  ((char)0x08) /* Legal 2nd btye of double byte stream */

#define iskana(c)   ((_jctype+1)[(unsigned char)(c)]&(_KNJ_M|_KNJ_P))
#define iskanji(c)  ((_jctype+1)[(unsigned char)(c)]&_KNJ_1)
#define iskanji2(c) ((_jctype+1)[(unsigned char)(c)]&_KNJ_2)

extern char _jctype[257];

extern unsigned short jmstojis( unsigned short c );

extern unsigned short jistojms( unsigned short c );

#endif

/*
 * (̾) isjiss --- ʸJISɤγϸؿ
 *        isjise --- ʸJISɤνλؿ
 *        
 * ()
 *        #include <jutil.h>
 *
 *        int isjiss( s )
 *        int isjise( s )
 *        unsigned char *s; ʸΥݥ
 *
 * ()
 *        ʸJISɤγ(λ)ɤޤޤƤ뤫ɤĴ٤.
 *        iskanji  iseuc Τ褦ʸΤΤǤϤʤ, 
 *        ʸƬˤʸǤ뤳Ȥ.
 */
/*
 * (̾) jis --- ܸJISʸ
 *
 * () JISɤɽʸ, ʸ(^[$B)Ƚλʸ(^[(J)
 *        Ϥޤ줿ʸΰ, 2ХȤJISɤǳǼ.
 */
extern char _JISB1[4];
extern char _JISB2[4];
extern char _JISE1[4];
extern char _JISE2[4];
extern char _JISE3[4];

#define isjiss(s) ((strncmp(s,_JISB1,3)==0)||\
		   (strncmp(s,_JISB2,3)==0))
#define isjise(s) ((strncmp(s,_JISE1,3)==0)||\
		   (strncmp(s,_JISE2,3)==0)||\
		   (strncmp(s,_JISE3,3)==0))

/*
 * (̾) iseuc  --- EUCδ̸ؿ
 *        iseuc2 --- EUCδ̸ؿ
 *        euctojis --- EUCJISؤΥѴ
 *        jistoeuc --- JISEUCؤΥѴ
 *        euctojms --- EUC饷եJISؤΥѴ
 *        jmstoeuc --- եJISEUCؤΥѴ
 *
 * ()
 *        #include <jutil.h>
 *
 *        int iseuc(c)
 *        int iseuc2(c)
 *        unsigned short c; оʸ
 *
 *        unsigned short euctojis( c )
 *        unsigned short jistoeuc( c )
 *        unsigned short euctojms( c )
 *        unsigned short jmstoeuc( c )
 *        unsigned short c; оʸ
 *
 * ()
 *        EUCܸ쥳ɤθ, JIS, եJISȤѴԤʤޤ.
 */
/*
 * (̾) eucj --- ܸEUCʸ
 *
 * () EUCɽʸ, ASCIIʸȾѤʸΰΥɤѤ, 
 *        ХȤJISɤ0x80ûɤǳǼ.
 */
#define iseuc(c)  (0xa0<=(c)&&(c)<0xe0)
#define iseuc2(c) (0xa1<=(c)&&(c)<0xff)

#define euctojis(u) ((u)-0x8080)
#define jistoeuc(u) ((u)+0x8080)
#define euctojms(u) jistojms(euctojis(u))
#define jmstoeuc(u) jistoeuc(jmstojis(u))

/*
 * (̾) _JCODES --- ܸ쥳
 *
 * ()
 *        #include <jutil.h>
 *
 *        enum _JCODES {
 *          JCT_ILGL = -1, // ꡼ʸ  //
 *          JCT_ANK,       // ASCIIͥʸ //
 *          JCT_SJ,        // եJISʸ     //
 *          JCT_JIS,       // JISʸ           //
 *          JCT_EUC        // EUCܸʸ     //
 *        };
 *
 * ()
 *        ص, ܸʸηϤʬह뤿󷿤Ǥ.
 */
enum _JCODES { JCT_ILGL = -1, JCT_ANK, JCT_SJ, JCT_JIS, JCT_EUC };

/*
 * (̾) jcode  --- Ϳ줿  ʸ  ɤΥηϤɽƤ뤫
 *        jfcode --- Ϳ줿ȥ꡼बɤΥηϤɽƤ뤫
 *
 * ()
 *        #include <jutil.h>
 *
 *        int jcode( unsigned char *str )
 *        unsigned char *str; ʸ
 *
 *        int jfcode( fp )
 *        FILE *fp; եݥ
 *
 * ()
 *        ʸ, ե뤬ɤΥηϤܸ줬ޤޤƤ뤫֤ޤ.
 *        ͤ _JCODES Ǥ.
 */
extern int jcode( unsigned char *str );
extern int jfcode( FILE *fp );

/*
 * (̾) sj2jis  --- ʸΥեJISJISѴؿ
 *        jis2sj  --- ʸJIS饷եJISѴؿ
 *        jis2euc --- ʸJISEUCɤѴؿ
 *        euc2jis --- ʸEUCJISɤѴؿ
 *        euc2sj  --- ʸEUC饷եJISѴؿ
 *        sj2euc  --- ʸΥեJISEUCѴؿ
 *        str2sj  --- ʸΥեJISѴؿ
 *        str2jis --- ʸJISɤѴؿ
 *        str2euc --- ʸEUCܸѴؿ
 *
 * ()
 *        #include <jutil.h>
 *
 *        sj2jis ( src, dst )
 *        jis2sj ( src, dst )
 *        jis2euc( src, dst )
 *        euc2jis( src, dst )
 *        euc2sj ( src, dst )
 *        sj2euc ( src, dst )
 *        str2sj ( src, dst )
 *        str2jis( src, dst )
 *        str2euc( src, dst )
 *        unsigned char *src; Ѵʸ
 *        unsigned char *dst; Ѵʸ
 *
 * ()
 *        ʸ󥳡ɴѴؿ(SJ<->JIS, JIS<->EUC, EUC<->SJ)Ǥ.
 *        dst ˤϽʬΰ褬ݤƤʤФʤޤ.
 */
extern void sj2jis ( unsigned char *src, unsigned char *dst );
extern void jis2sj ( unsigned char *src, unsigned char *dst );
extern void jis2euc( unsigned char *src, unsigned char *dst );
extern void euc2jis( unsigned char *src, unsigned char *dst );
extern void euc2sj ( unsigned char *src, unsigned char *dst );
extern void sj2euc ( unsigned char *src, unsigned char *dst );
extern void str2sj ( unsigned char *src, unsigned char *dst );
extern void str2jis( unsigned char *src, unsigned char *dst );
extern void str2euc( unsigned char *src, unsigned char *dst );

/*
 * (̾) setjcode --- Ϥؤˤ뤿Υȴؿ
 *        getjcode --- ȴɤؿ
 *
 * () setjcode( jcode )
 *        enum _JCODES jcode; ȴ
 *
 *        enum _JCODES getjcode( void )
 *        ͤϥȴ
 *
 * () ȴɤꤷ, ϤץॽɤǤ
 *        Ϥꤵ줿ɤˤ뤿Υ롼󽸤ˤ
 *        ȴɤ, ؿǤ.
 *        ˤä椵ΤϰʲΥ롼Ǥ.
 *
 *        jfputs, jputs --- Ϥ˴ؤؿ
 *        jfgets, jgets --- Ϥ˴ؤؿ
 *
 *        ϤǤʸ󤬲ΥɤǤ⥫ȴɤǽϤޤ.
 *        ϤǤʸ󤬲ΥɤǤ⥫ȴɤǳǼޤ.
 */
extern void setjcode( int c );
extern int getjcode( void );

/*
 * (̾)
 *        jfputs --- ȴɤǥȥ꡼Ϥؿ
 *        jputs  --- ȴɤɸϤؿ
 *        jfgets --- ȴɤǥȥ꡼Ϥؿ
 *        jgets  --- ȴɤɸϤؿ
 *
 * () 
 *        int jfputs( str, fp )
 *        char *str; ʸ
 *        FILE *fp;  ե륹ȥ꡼
 *        Ǥʤ, Ԥ EOF
 *
 *        int jputs( src )
 *        char *str; ʸ
 *        Ǥʤ, Ԥ EOF
 *
 *        char *jfgets( str, n, fp )
 *        char *str; ʸ
 *        size_t n;  Хåե
 *        FILE *fp;  ե륹ȥ꡼
 *         str ؤΥݥ, Ԥ NULL
 *
 *        char *jgets ( str )
 *        char *str; ʸ
 *         str ؤΥݥ, Ԥ NULL
 *
 * ()
 *        ϤǤʸ󤬲ΥɤǤ⥫ȴɤǽϤޤ.
 *        ϤǤʸ󤬲ΥɤǤ⥫ȴɤǳǼޤ.
 */
extern int sjfputs( unsigned char *src, FILE *fp );
extern int sjputs ( unsigned char *str );
extern int jisfputs( unsigned char *src, FILE *fp );
extern int jisputs ( unsigned char *str );
extern int eucfputs( unsigned char *src, FILE *fp );
extern int eucputs ( unsigned char *str );
extern int jfputs( unsigned char *str, FILE *fp );
extern int jputs ( unsigned char *str );
extern char *jfgets( unsigned char *str, size_t n, FILE *fp );
extern char *jgets ( unsigned char *str );

#endif
