/*
 * Source File < ps/text.c >
 *
 * Standard Functions: Borland Graphics Interface for PostScript
 *
 * Copyright (c) 1992-94,95 Tokyo Denki University, Taiji Yamada
 */
#include "ps_p.h"

/*
 * standard function to out text on graphics
 */
void outtextxy( int x, int y, char *textstring );
void outtext( char *textstring )
{
  outtextxy( XBGI->cp.x, XBGI->cp.y, textstring );
  moverel( (XBGI->textset.direction==HORIZ_DIR)?textwidth(textstring):0,
          (XBGI->textset.direction==VERT_DIR)?textwidth(textstring):0 );
}
void outtextxy( int x, int y, char *textstring )
{
  int font = XBGI->textset.font;
  int dir  = XBGI->textset.direction;
  int size = XBGI->textset.charsize;
  int width = textwidth(textstring), height = textheight(textstring);


  switch ( dir ){
  case VERT_DIR:
    /*
     * vertical direction
     */
    if ( !XBGI->l10n || font != DEFAULT_FONT ){
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += TextAscent( PSBGIStrokeFonts[font][size] );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x -= TextDescent( PSBGIStrokeFonts[font][size] );
        break;
      }
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += TextAscent( PSBGIStrokeFonts[font][size] );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x -= TextDescent( PSBGIStrokeFonts[font][size] );
        break;
      }
#endif
#ifdef ENABLE_BILINGUAL
      switch( XBGI->textset.horiz ){
      case LEFT_TEXT:
        x += max( TextAscent( PSBGIStrokeFonts[font][size] ),
                 TextAscent( PSBGIBiFonts[size] ) );
        break;
      case CENTER_TEXT:
        x += height/2;
        break;
      case RIGHT_TEXT:
        x += max( TextDescent( PSBGIStrokeFonts[font][size] ),
                 TextDescent( PSBGIBiFonts[size] ) );
        break;
      }
#endif
    }
  case HORIZ_DIR:
    /*
     * horizontal direction
     */
    if ( !XBGI->l10n || font != DEFAULT_FONT ){
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += TextAscent( PSBGIStrokeFonts[font][size] );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= TextDescent( PSBGIStrokeFonts[font][size] );
        break;
      }
    }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += TextAscent( PSBGIStrokeFonts[font][size] );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= TextDescent( PSBGIStrokeFonts[font][size] );
        break;
      }
#endif
#ifdef ENABLE_BILINGUAL
      switch( XBGI->textset.vert ){
      case TOP_TEXT:
        y += max( TextAscent( PSBGIStrokeFonts[font][size] ),
                 TextAscent( PSBGIBiFonts[size] ) );
        break;
      case CENTER_TEXT:
        y += height/2;
        break;
      case BOTTOM_TEXT:
        y -= max( TextDescent( PSBGIStrokeFonts[font][size] ),
                 TextDescent( PSBGIBiFonts[size] ) );
        break;
      }
#endif
    }
    break;
  }
  ps_xbgi_begin( "outtextxy" );
  ps_xbgi_put_color( XBGI->color );
  if ( !XBGI->l10n || font != DEFAULT_FONT ){
    ps_xbgi_printf( "/%s findfont [%g %g %g %g %g %g] makefont setfont\n",
		   PSBGIStrokeFonts[font][size]->name,
		   PSBGIStrokeFonts[font][size]->tm[0][0],
		   PSBGIStrokeFonts[font][size]->tm[0][1],
		   PSBGIStrokeFonts[font][size]->tm[0][2],
		   PSBGIStrokeFonts[font][size]->tm[1][0],
		   PSBGIStrokeFonts[font][size]->tm[1][1],
		   PSBGIStrokeFonts[font][size]->tm[1][2] );
  }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
    ps_xbgi_printf( "/%s findfont [%g %g %g %g %g %g] makefont setfont\n",
		   PSBGIStrokeFonts[font][size]->name,
		   PSBGIStrokeFonts[font][size]->tm[0][0],
		   PSBGIStrokeFonts[font][size]->tm[0][1],
		   PSBGIStrokeFonts[font][size]->tm[0][2],
		   PSBGIStrokeFonts[font][size]->tm[1][0],
		   PSBGIStrokeFonts[font][size]->tm[1][1],
		   PSBGIStrokeFonts[font][size]->tm[1][2] );
#endif
#ifdef ENABLE_BILINGUAL
    ps_xbgi_printf( "/%s-%s /%s /%s eucfont\n",
		   PSBGIStrokeFonts[font][size]->name,
		   PSBGIBiFonts[size]->name,
		   PSBGIStrokeFonts[font][size]->name,
		   PSBGIBiFonts[size]->name );
    ps_xbgi_printf( "/%s-%s findfont [%g %g %g %g %g %g] makefont setfont\n",
		   PSBGIStrokeFonts[font][size]->name,
		   PSBGIBiFonts[size]->name,
		   PSBGIBiFonts[size]->tm[0][0],
		   PSBGIBiFonts[size]->tm[0][1],
		   PSBGIBiFonts[size]->tm[0][2],
		   PSBGIBiFonts[size]->tm[1][0],
		   PSBGIBiFonts[size]->tm[1][1],
		   PSBGIBiFonts[size]->tm[1][2] );
#endif
  }
  ps_xbgi_flush();
  ps_xbgi_printf( "gsave\n" );
  ps_xbgi_printf( "%d %d moveto\n", Xx(x), Xy(y) );
  if ( dir == VERT_DIR )
    ps_xbgi_printf( "270 rotate\n" );
  ps_xbgi_printf( " (" );
  if ( !XBGI->l10n || font != DEFAULT_FONT ){
    ps_xbgi_put_string( textstring, strlen(textstring) );
  }else{
#if !defined( ENABLE_BILINGUAL ) && !defined( ENABLE_MULTILINGUAL )
    ps_xbgi_put_string( textstring, strlen(textstring) );
#endif
#ifdef ENABLE_BILINGUAL
    ps_xbgi_put_bi_string( textstring, strlen(textstring) );
#endif
  }
  ps_xbgi_printf( ") " );
  switch( XBGI->textset.horiz ){
  case LEFT_TEXT:
    ps_xbgi_printf( "show\n" );
    break;
  case CENTER_TEXT:
    ps_xbgi_printf( "xbgicentertext show\n" );
    break;
  case RIGHT_TEXT:
    ps_xbgi_printf( "xbgirighttext show\n" );
    break;
  }
  if ( dir == VERT_DIR )
    ps_xbgi_printf( "  -270 rotate\n" );
  ps_xbgi_printf( "grestore\n" );
  ps_xbgi_end( "outtextxy" );
}











