/*
 * Source File < ps/viewport.c >
 *
 * Standard Functions: Borland Graphics Interface for PostScript
 *
 * Copyright (c) 1992-94,95 Tokyo Denki University, Taiji Yamada
 */
#include "ps_p.h"

/*
 * standard functions for viewport as virtual drawing device
 */
void clearviewport( void )
{
  int left, top, right, bottom;
  
  left   = XBGI->viewport.left;
  top    = XBGI->viewport.top;
  right  = XBGI->viewport.right;
  bottom = XBGI->viewport.bottom;
  if ( XBGI->viewport.clip ){
    ps_xbgi_put_color( XBGI->bkcolor );
    ps_xbgi_printf( "newpath\n" );
    ps_xbgi_printf( "  %d %d moveto\n", Xx(left),  Xy(top)    );
    ps_xbgi_printf( "  %d %d lineto\n", Xx(right), Xy(top)    );
    ps_xbgi_printf( "  %d %d lineto\n", Xx(right), Xy(bottom) );
    ps_xbgi_printf( "  %d %d lineto\n", Xx(left),  Xy(bottom) );
    ps_xbgi_printf( "closepath fill\n" );
  }else
    cleardevice();
}
void setviewport( int left, int top, int right, int bottom, int clip )
{
  XBGI->viewport.left   = min( left, right );
  XBGI->viewport.top    = min( top, bottom );
  XBGI->viewport.right  = max( left, right );
  XBGI->viewport.bottom = max( top, bottom );
  XBGI->viewport.clip   = clip;
  if ( XBGI->viewport.clip ){
    if ( PSBGIRoot.drawn ){
      ps_xbgi_begin( "setviewport with clip" );
      ps_xbgi_printf( "newpath\n" );
      ps_xbgi_printf( "  %d %d moveto\n", Xx(left),  Xy(top)    );
      ps_xbgi_printf( "  %d %d lineto\n", Xx(right), Xy(top)    );
      ps_xbgi_printf( "  %d %d lineto\n", Xx(right), Xy(bottom) );
      ps_xbgi_printf( "  %d %d lineto\n", Xx(left),  Xy(bottom) );
      ps_xbgi_printf( "closepath clip\n" );
      ps_xbgi_end( "setviewport with clip" );
    }
  }
}
void getviewsettings( struct viewporttype *viewport )
{
  *viewport = XBGI->viewport;
}











