/*
 * Source File < x11/event.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94,95 Tokyo Denki University, Taiji Yamada
 */
#include "x11_p.h"

/*
 * event loop with tools
 */
/* menu defined */
enum MENU_ITEM {
  NO_SELECT = -1,
  SAVE_XBM,
#ifdef ENABLE_XPMLIB
  SAVE_XPM,
#endif
#ifndef BUILD_STANDALONE
  SAVE_PS,
#endif
  QUIT,
};
static char *MENU_TITLE = "menu";
static int   MENU_ITEMC = QUIT+1;
static int   MENU_ITEMI = NO_SELECT;
static char *MENU_ITEMV[] = {
  "save bitmap",
#ifdef ENABLE_XPMLIB
  "save pixmap",
#endif
#ifndef BUILD_STANDALONE
  "save ps",
#endif
  "quit (q)"
};
/* about, info and help defined */
#define ABOUT "xbgi\n"\
              "version 3.0\n"\
              "Borland Graphics Interface\n"\
              "for X11, PostScript, TclTk and TGIF.\n"\
              "produced by Taiji Yamada, 1992-94,95"
#define INFO  "id          %d\n"\
              "driver      %s\n"\
              "mode        %s\n"\
              "visual page %d\n"\
              "active page %d\n"\
              "pages       %d\n"\
              "color       %d\n"\
              "bkcolor     %d\n"\
              "ncolor      %d\n",\
              XBGI->id,\
              getdriversname(XBGI->gdriver),\
              getmodename(XBGI->gmode),\
              XBGI->apage,\
              XBGI->vpage,\
              XBGI->npage,\
              XBGI->color,\
              XBGI->bkcolor,\
              XBGI->ncolor
#define HELP  "-display display      X display name.\n"\
              "-geometry geometry    Window size and position.\n"\
              "-fn font              Font of popup text.\n"\
              "-fg color             Foreground color of popup text.\n"\
              "-bg color             Background color of popup text.\n"\
              "-title string         Title of graphic window.\n"\
              "-name name            Resouce name of graphic window.\n"\
              "-icon file            Icon bitmap filename.\n"\
              "-backing[-]           Backing store on[off].\n"\
              "-gd driver            Driver name X11, PS, TCLTK and TGIF.\n"\
              "-gm mode              Mode name X11MONO, X11COLOR etc.\n"\
              "-ncolor number        The number of graphic color.\n"\
              "-color number         Graphic forground color number.\n"\
              "-bkcolor number       Graphic background color number.\n"\
              "-npage number         The number of graphic page.\n"\
              "-colornames colorlist X named color list for graphic.\n"\
              "-only-ascii[-]        Bi-or-Multilingual text off[on].\n"\

/*
 * default event procs
 */
int xbgi_button_press( int button, int x, int y )
{
  static char xbmfilename[80], xbmfilenamebak[80] = "scratch.xbm";
  static char xpmfilename[80], xpmfilenamebak[80] = "scratch.xpm";
  static char epsfilename[80], epsfilenamebak[80] = "scratch.eps";
  char bgisetstr[1024];
  int status;

  switch( button ){
  case 1:
    break;
  case 2:
    bgimenu( MENU_TITLE, MENU_ITEMC, MENU_ITEMV, &MENU_ITEMI );
    switch( MENU_ITEMI ){
    case NO_SELECT:
      break;
    case SAVE_XBM:
      strcpy( xbmfilename, xbmfilenamebak );
      bgigets( "XBM NAME", 80, xbmfilename );
      if ( strcmp(xbmfilename,"") != 0 ){
        status = savegraphtoxbm( xbmfilename );
        strcpy( xbmfilenamebak, xbmfilename );
        if ( !status )
          bgiprintf( "Error!", CENTER_TEXT, "saving bitmap is failed" );
      }else{
        strcpy( xbmfilename, xbmfilenamebak );
      }
      break;
#ifdef ENABLE_XPMLIB
    case SAVE_XPM:
      strcpy( xpmfilename, xpmfilenamebak );
      bgigets( "XPM NAME", 80, xpmfilename );
      if ( strcmp(xpmfilename,"") != 0 ){
        status = savegraphtoxpm( xpmfilename );
        strcpy( xpmfilenamebak, xpmfilename );
        if ( !status )
          bgiprintf( "Error!", CENTER_TEXT, "saving pixmap is failed" );
      }else{
        strcpy( xpmfilename, xpmfilenamebak );
      }
      break;
#endif
#ifndef BUILD_STANDALONE
    case SAVE_PS:
      if ( XBGI->inherit_procedures->expose_handler ){
	strcpy( epsfilename, epsfilenamebak );
	bgigets( "(E)PS NAME", 80, epsfilename );
	if ( strcmp(epsfilename,"") != 0 ){
	  char *ptr;
	  xbgi *xptr = XBGI;
	  int (*expose)(void) = XBGI->inherit_procedures->expose_handler;
	  int gd = PS, gm = PSCOLOR, i;
	  struct palettetype p;
	  
	  /* start postscript graphics system */
	  getpalette( &p );
	  sprintf( bgisetstr, "-geometry %1dx%1d -psfile %s ",
		  getmaxx()+1, getmaxy()+1, epsfilename );
	  switch ( XBGI->gmode ){
	  case X11MONO:
	  default:
	    strcat( bgisetstr, "-gd PS -gm PSMONO " );
	    break;
	  case X11SGRAY:
	  case X11GRAY: 
	    strcat( bgisetstr, "-gd PS -gm PSGRAY " );
	    break;
	  case X11SCOLOR:
	  case X11COLOR:
	    strcat( bgisetstr, "-gd PS -gm PSCOLOR " );
	    break;
	  }
	  if ( (ptr=strstr(epsfilename,".eps")) == NULL )
	    strcat( bgisetstr, "-eps-" );
	  else
	    strcat( bgisetstr, "-eps" );
	  initgraph( &gd, &gm, bgisetstr );
	  ps_setmaxcolor( xptr->ncolor );
	  for ( i=0; i<xptr->ncolor; i++ )
	    ps__setrgbpalette( i,
			      XBGIsRGB(xptr)[i].red,
			      XBGIsRGB(xptr)[i].green,
			      XBGIsRGB(xptr)[i].blue );
	  ps_setallpalette( &p );
	  expose();
	  closegraph();
	  XBGI = xptr;
	  strcpy( epsfilenamebak, epsfilename );
	  /*if ( !status )
	    bgiprintf( "Error!", LEFT_TEXT, "saving ps is failed" );*/
	}else{
	  strcpy( xpmfilename, xpmfilenamebak );
	}
      }else{
	bgiprintf( "Error!", LEFT_TEXT,
		  "No your 'expose' procedure!\n"
		  "Please set expose procedure before xbgiloop.\n"
		  "when you want to save PostScript as follows:\n"
		  "--------------------------------------------\n"
		  "  int my_expose( void )\n"
		  "  {\n"
		  "    /* your drawing code */\n"
		  "  }\n"
		  "  int main( void )\n"
		  "  {\n"
		  "      :\n"
		  "    set_expose_handler( my_expose );\n"
		  "    xbgiloop();\n"
		  "      :\n"
		  "  }\n" );
      }
      break;
#endif /* BUILD_STANDALONE */
    case QUIT:
      return 0;
      break;
    }
    break;
  case 3:
    return 0;
    break;
  }
  return !0;
}
int xbgi_button_release( int button, int x, int y )
{
  return !0;
}
int xbgi_mouse_motion( int button_state, int x, int y )
{
  return !0;
}
int xbgi_page_enter( int page )
{
  return !0;
}
int xbgi_page_leave( int page )
{
  return !0;
}
int xbgi_key_press( int c )
{
  int i;
  char buf[1024];

  switch( c ){
  case CTRL('a'):
    bgiprintf( "about", CENTER_TEXT, ABOUT );
    break;
  case CTRL('i'):
    bgiprintf( "info.", LEFT_TEXT, INFO );
    break;
  case CTRL('o'):
    strcpy( buf, "" );
    for ( i=0; i<XBGI->argc; i++ ){
      if ( XBGI->argv[i][0] == '-' )
        strcat( buf, "\n" );
      strcat( buf, XBGI->argv[i] );
      if ( XBGI->argv[i][0] == '-' )
        strcat( buf, " " );
    }
    bgiprintf( "options", LEFT_TEXT, "%s", buf );
    break;
  case CTRL('h'):
    bgiprintf( "help", LEFT_TEXT, HELP );
    break;
  case 'n': case 'N':
    setvisualpage( min( XBGI->vpage+1, XBGI->npage-1 ) );
    break;
  case 'b': case 'B':
    setvisualpage( XBGI->vpage-1 );
    break;
  case CTRL('f'):
    if ( XBGI->vpage != XBGI->npage )
      setvisualpage( XBGI->npage );
    else
      setvisualpage( 0 );
    break;
  case CTRL('c'):
    exit( 0 );
    break;
  case 'q': case 'Q': case 0x1b:
    return 0;
    break;
  }
  return !0;
}
int xbgi_configure( void )
{
  return !0;
}
int xbgi_expose( void )
{
  return !0;
}
int xbgi_noevent( void )
{
  return !0;
}

/*
 * event looper for simple event programing
 */
void xbgiloop( void )
{
  xbgi *ptr;
  XEvent ev, ahead;
  int b, bs, p;
  char c;
  int ret;
  
  /*
   * flush all xbgi
   */
  ptr = XBGIS;
  while ( ptr != NULL ){
    XFlush( XBGIsDisplay(ptr) );
    ptr = ptr->next;
  }
  ptr = XBGI;
  XBGI = XBGIS;
  /*
   * finite event roop
   */
  while ( !0 ){
    if ( XBGI == NULL ){
      XBGI = XBGIS;
      continue;
    }
    ret = !0;
    if ( XEventsQueued( XBGIDisplay, QueuedAfterFlush ) > 0 ){
      XNextEvent( XBGIDisplay, &ev );
      switch ( ev.type ){
      case ButtonPress:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->button_press_handler != NULL ){
          switch( ev.xbutton.button ){
          case Button1: b = 1; break;
          case Button2: b = 2; break;
          case Button3: b = 3; break;
          }
          ret = XBGI->inherit_procedures->button_press_handler( b, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case ButtonRelease:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->button_release_handler != NULL ){
          switch( ev.xbutton.button ){
          case Button1: b = 1; break;
          case Button2: b = 2; break;
          case Button3: b = 3; break;
          }
          ret = XBGI->inherit_procedures->button_release_handler( b, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case MotionNotify:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->mouse_motion_handler != NULL ){
          bs = 0;
          if ( ev.xmotion.state & Button1Mask ) bs |= 1;
          if ( ev.xmotion.state & Button2Mask ) bs |= 2;
          if ( ev.xmotion.state & Button3Mask ) bs |= 4;
          ret = XBGI->inherit_procedures->mouse_motion_handler( bs, ev.xbutton.x, ev.xbutton.y );
        }
        break;
      case EnterNotify:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->page_enter_handler != NULL ){
          for ( p=0; p<XBGI->npage; p++ )
            if ( XBGIWins[p] == ev.xcrossing.window )
              ret = XBGI->inherit_procedures->page_enter_handler( p );
        }
        break;
      case LeaveNotify:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->page_leave_handler != NULL ){
          for ( p=0; p<XBGI->npage; p++ )
            if ( XBGIWins[p] == ev.xcrossing.window )
              ret = XBGI->inherit_procedures->page_leave_handler( p );
        }
        break;
      case KeyPress:
        if ( XLookupString( (XKeyEvent*)&ev, &c, 1, NULL, NULL ) == 1 ){
         XBGIEvent = ev;
          if ( XBGI->inherit_procedures->key_press_handler != NULL )
            ret = XBGI->inherit_procedures->key_press_handler( c );
        }
        break;
      case ConfigureNotify:
        XBGIEvent = ev;
        if ( XBGI->inherit_procedures->configure_handler != NULL )
          ret = XBGI->inherit_procedures->configure_handler();
        break;
      case Expose:
        XBGIEvent = ev;
        while ( XEventsQueued(ev.xexpose.display,QueuedAfterReading) > 0 ){
          XPeekEvent( ev.xexpose.display, &ahead );
          if ( ahead.type != Expose )
            break;
          if ( ahead.xexpose.window != ev.xexpose.window )
            break;
          XNextEvent( ev.xexpose.display, &ev );
        }
        if ( XBGI->inherit_procedures->expose_handler != NULL )
          ret = XBGI->inherit_procedures->expose_handler();
        break;
      }
    }else{
      if ( XBGI->inherit_procedures->noevent_handler != NULL )
        ret = XBGI->inherit_procedures->noevent_handler();
    }
    if ( !ret ){
      XBGI = ptr;
      return;
    }
    XBGI = XBGI->next;
  }
}
/*
 * is event
 */
int isevent( void )
{
  if ( XEventsQueued( XBGIDisplay, QueuedAfterFlush ) > 0 )
    return !0;
  else
    return 0;
}







