/*
 * Source File < x11/pixel.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94,95 Tokyo Denki University, Taiji Yamada
 */
#include "x11_p.h"

/*
 * standard function to get and put pixel color
 */
unsigned getpixel( int x, int y )
{
  XImage *image;
  unsigned char val;

  image = XGetImage( XBGIDisplay, XBGIWins[XBGI->apage],
                    Xx( x ), Xy( y ), 1, 1, AllPlanes, ZPixmap );
  val = XBGIColortable[image->data[image->xoffset]];
  XDestroyImage( image );
  return (unsigned)val;
}
void putpixel( int x, int y, int color )
{
  XSetForeground( XBGIDisplay, XBGIPixelGC,
                 XBGIPixels[minmax(0,color,XBGI->palette.size-1)] );
  XDrawPoint( XBGIDisplay, XBGIWins[XBGI->apage], XBGIPixelGC, Xx(x), Xy(y) );
}
void putpixels( int numpoints, int *points, int color )
{
  XPoint *xpoints = (XPoint *)malloc( numpoints * sizeof(XPoint) );
  
  XSetForeground( XBGIDisplay, XBGIPixelGC,
                 XBGIPixels[minmax(0,color,XBGI->palette.size-1)] );
  bgipoints2XPoints( numpoints, points, xpoints );
  XDrawPoints( XBGIDisplay, XBGIWins[XBGI->apage], XBGIPixelGC,
	      xpoints, numpoints, CoordModeOrigin );
  free( xpoints );
}











